/***************************************************************/
/* TENTM software accompanying JCTVC-A119                      */
/* Copyright Tandberg, Ericsson, Nokia, 2010                   */
/***************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "getvlc.h"
#include "rfutil.h"

extern int trace;
extern FILE *tracefile;
extern FILE *dbgfile;
extern FILE *rftrace;


typedef struct {
    int level;
    int last_pos;
} cstruct;


// ADAPT_VLC_NUM
const int last_pos_vlcnum[10][17] =
{
    {10,10,10,10, 2,2,2,7,9,9,9,9,9,4,4,4,4},
    {10,10,10,10,10,2,9,9,9,9,9,9,9,4,4,4,4},
    { 2, 2, 2, 2, 2,7,7,7,7,7,7,7,7,7,4,4,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    {10, 1, 2, 2, 2,2,7,7,7,7,9,9,9,4,4,4,4},
    {10,10, 2, 2, 7,7,7,7,7,7,7,7,4,4,4,4,4},
    {10,10, 2, 2, 7,7,7,7,7,7,7,7,4,4,4,4,4},

    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4}
};

/*
static const cstruct last_pos_table[128] =
    {
        {0,0},{0,2},{0,1},{0,3},{0,5},{0,9},{0,4},{0,10},
        {0,42},{0,20},{0,8},{0,7},{0,6},{0,27},{0,14},{0,11},
        {0,43},{0,28},{0,41},{0,12},{0,13},{0,19},{0,15},{0,18},
        {0,53},{0,29},{0,26},{0,21},{0,30},{0,17},{0,24},{0,31},
        {0,25},{0,16},{0,44},{0,40},{0,32},{0,35},{0,23},{0,22},
        {0,33},{0,39},{0,45},{0,34},{0,38},{0,46},{0,52},{0,47},
        {0,48},{0,37},{0,36},{0,49},{0,54},{0,51},{0,50},{0,57},
        {0,55},{1,0},{0,56},{0,60},{1,2},{0,58},{0,59},{1,1},
        {1,28},{1,5},{1,42},{1,4},{1,3},{1,9},{0,61},{0,62},
        {1,43},{1,35},{1,21},{1,20},{1,27},{1,53},{1,10},{1,6},
        {1,14},{0,63},{1,8},{1,41},{1,15},{1,7},{1,29},{1,48},
        {1,11},{1,44},{1,49},{1,13},{1,36},{1,12},{1,18},{1,19},
        {1,30},{1,24},{1,31},{1,32},{1,26},{1,40},{1,25},{1,47},
        {1,17},{1,57},{1,23},{1,45},{1,46},{1,54},{1,16},{1,22},
        {1,34},{1,52},{1,39},{1,33},{1,37},{1,38},{1,50},{1,55},
        {1,60},{1,51},{1,56},{1,58},{1,59},{1,61},{1,62},{1,63}
    };
*/
static const cstruct luma_run_8x8[29][127] =
    {
        {{0,1},{0,0},{1,0},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,2},{0,1},{0,0},{1,1},{1,0},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,3},{0,0},{0,2},{0,1},{1,0},{1,2},{1,1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,4},{0,1},{0,0},{0,2},{0,3},{1,1},{1,0},{1,2},{1,3},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,5},{0,0},{0,3},{0,2},{0,4},{0,1},{1,0},{1,3},{1,2},{1,4},{1,1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,6},{0,0},{0,1},{0,4},{0,5},{0,3},{0,2},{1,0},{1,1},{1,4},{1,3},{1,2},{1,5},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,7},{0,1},{0,0},{0,2},{0,4},{0,3},{0,6},{0,5},{1,1},{1,0},{1,2},{1,4},{1,3},{1,5},{1,6},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,8},{0,0},{0,3},{0,4},{0,2},{0,1},{0,5},{0,7},{0,6},{1,0},{1,3},{1,4},{1,2},{1,1},{1,5},{1,6},{1,7},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,9},{0,0},{0,5},{0,1},{0,6},{0,4},{0,8},{0,3},{0,2},{0,7},{1,0},{1,5},{1,1},{1,6},{1,4},{1,3},{1,2},{1,8},{1,7},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1}},

        {{0,10},{0,0},{0,1},{0,6},{0,7},{0,2},{0,9},{0,5},{1,0},{0,4},{0,3},{0,8},{1,1},{1,6},{1,7},{1,2},{1,5},{1,3},{1,4},{1,9},{1,8},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1}},

        {{0,11},{0,1},{0,0},{0,2},{0,3},{0,6},{0,7},{0,4},{0,5},{0,8},{0,10},{0,9},{1,1},{1,0},{1,2},{1,3},{1,6},{1,4},{1,5},{1,7},{1,8},{1,10},
         {1,9},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1}},

        {{0,12},{0,0},{0,3},{0,2},{0,1},{0,4},{0,6},{0,5},{0,7},{0,11},{0,8},{0,9},{0,10},{1,0},{1,3},{1,2},{1,4},{1,1},{1,6},{1,5},{1,7},{1,11},
         {1,8},{1,9},{1,10},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1}},

        {{0,13},{0,0},{0,1},{0,5},{0,6},{0,4},{0,2},{0,3},{0,7},{0,8},{0,12},{0,10},{0,11},{0,9},{1,0},{1,5},{1,1},{1,6},{1,2},{1,4},{1,7},{1,3},
         {1,8},{1,10},{1,11},{1,12},{1,9},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1}},

        {{0,14},{0,0},{0,1},{0,7},{0,2},{0,8},{0,6},{0,5},{0,3},{0,4},{0,13},{0,12},{0,9},{0,11},{0,10},{1,0},{1,1},{1,7},{1,8},{1,2},{1,6},{1,3},
         {1,5},{1,4},{1,12},{1,13},{1,9},{1,11},{1,10},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1}},

        {{0,15},{0,0},{0,1},{0,2},{0,8},{0,3},{0,9},{0,7},{0,6},{0,4},{0,5},{1,0},{0,14},{0,10},{0,13},{0,12},{0,11},{1,1},{1,2},{1,8},{1,3},{1,9},
         {1,4},{1,6},{1,5},{1,13},{1,7},{1,10},{1,14},{1,12},{1,11},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,16},{0,0},{0,1},{0,2},{0,3},{0,4},{0,8},{0,7},{0,5},{0,9},{0,6},{0,10},{0,15},{0,11},{1,0},{0,13},{0,14},{1,1},{0,12},{1,2},{1,3},{1,4},
         {1,8},{1,5},{1,7},{1,6},{1,9},{1,10},{1,13},{1,11},{1,15},{1,12},{1,14},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,17},{0,0},{0,3},{0,1},{0,2},{0,4},{0,5},{0,8},{0,9},{0,7},{0,6},{0,10},{0,11},{0,12},{0,16},{1,0},{0,13},{0,14},{0,15},{1,1},{1,3},
         {1,4},{1,2},{1,8},{1,5},{1,7},{1,6},{1,9},{1,12},{1,11},{1,13},{1,16},{1,10},{1,14},{1,15},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,18},{0,0},{0,1},{0,5},{0,2},{0,6},{0,4},{0,3},{0,7},{0,8},{0,9},{0,10},{0,17},{0,13},{0,14},{0,12},{1,0},{0,15},{0,11},{0,16},{1,5},
         {1,1},{1,6},{1,8},{1,2},{1,3},{1,4},{1,7},{1,9},{1,13},{1,10},{1,12},{1,17},{1,15},{1,14},{1,11},{1,16},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,19},{0,0},{0,1},{0,7},{0,8},{0,2},{0,6},{0,3},{0,9},{0,4},{0,5},{0,10},{0,18},{0,15},{0,16},{0,14},{1,0},{0,11},{0,13},{0,17},{0,12},
         {1,1},{1,8},{1,7},{1,2},{1,3},{1,9},{1,6},{1,5},{1,4},{1,16},{1,10},{1,15},{1,14},{1,12},{1,18},{1,11},{1,13},{1,17},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,20},{0,0},{0,9},{0,1},{0,10},{0,2},{0,8},{0,3},{0,7},{0,4},{0,16},{0,17},{0,6},{0,19},{0,5},{0,11},{0,15},{1,0},{0,12},{1,9},{0,14},
         {0,13},{0,18},{1,1},{1,10},{1,2},{1,8},{1,3},{1,17},{1,4},{1,7},{1,5},{1,16},{1,6},{1,19},{1,11},{1,15},{1,12},{1,18},{1,13},{1,14},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,0},{0,21},{0,1},{0,10},{0,2},{0,11},{1,0},{0,3},{0,9},{0,5},{0,4},{0,17},{0,20},{0,18},{0,8},{0,7},{0,6},{0,12},{0,16},{0,13},{0,15},
         {0,19},{0,14},{1,1},{1,10},{1,2},{1,11},{1,4},{1,17},{1,3},{1,6},{1,5},{1,9},{1,18},{1,7},{1,20},{1,12},{1,15},{1,8},{1,14},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,13},{1,16},{1,19},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1}},

        {{0,22},{0,1},{0,0},{0,2},{0,3},{0,4},{0,10},{0,11},{0,5},{0,6},{0,9},{0,7},{0,12},{0,8},{0,13},{0,18},{0,21},{1,1},{0,17},{0,19},{1,0},
         {0,14},{0,20},{0,16},{0,15},{1,2},{1,3},{1,4},{1,5},{1,10},{1,9},{1,6},{1,11},{1,12},{1,7},{1,8},{1,13},{1,14},{1,17},{1,18},{1,19},{1,20},
         {1,21},{1,15},{1,16},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,23},{0,0},{0,3},{0,4},{0,2},{0,1},{0,5},{0,7},{0,6},{0,10},{0,11},{0,8},{0,9},{0,12},{0,13},{0,14},{0,22},{0,18},{0,15},{0,19},{0,20},
         {0,17},{0,16},{1,3},{1,4},{0,21},{1,0},{1,2},{1,1},{1,5},{1,10},{1,6},{1,7},{1,11},{1,9},{1,12},{1,14},{1,13},{1,8},{1,22},{1,17},{1,18},
         {1,20},{1,15},{1,16},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,19},{1,21},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,24},{0,0},{0,5},{0,6},{0,1},{0,4},{0,3},{0,7},{0,2},{0,8},{0,10},{0,11},{0,9},{0,12},{0,15},{0,14},{0,13},{0,23},{0,16},{0,19},{0,17},
         {0,18},{0,21},{0,20},{1,0},{0,22},{1,5},{1,6},{1,1},{1,3},{1,11},{1,4},{1,10},{1,2},{1,7},{1,8},{1,9},{1,12},{1,14},{1,18},{1,13},{1,21},
         {1,15},{1,19},{1,23},{1,16},{1,20},{1,17},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,22},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},
        {{0,0},{0,25},{0,7},{0,1},{0,8},{0,6},{0,5},{0,2},{0,9},{0,10},{0,4},{0,11},{0,3},{0,12},{1,0},{0,17},{0,16},{0,13},{0,24},{0,18},{0,19},
         {0,15},{0,20},{0,23},{0,14},{0,21},{0,22},{1,7},{1,1},{1,9},{1,8},{1,6},{1,10},{1,4},{1,2},{1,5},{1,3},{1,11},{1,14},{1,16},{1,12},{1,21},
         {1,22},{1,24},{1,15},{1,20},{1,13},{1,17},{1,18},{1,19},{1,23},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},
        {{0,0},{0,26},{0,1},{0,9},{0,10},{0,2},{0,8},{0,11},{0,7},{0,3},{0,6},{0,5},{0,12},{0,4},{0,19},{0,13},{0,18},{1,0},{0,20},{0,14},{0,17},
         {0,25},{0,21},{0,16},{0,23},{0,24},{0,15},{0,22},{1,1},{1,10},{1,9},{1,2},{1,11},{1,8},{1,7},{1,4},{1,3},{1,6},{1,12},{1,5},{1,20},{1,19},
         {1,25},{1,13},{1,18},{1,16},{1,17},{1,24},{1,22},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,14},{1,15},{1,21},{1,23},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},
        {{0,27},{0,0},{0,1},{0,11},{0,2},{0,10},{0,12},{0,3},{0,9},{0,7},{0,8},{0,4},{0,6},{0,20},{0,13},{0,5},{0,14},{0,26},{1,0},{0,21},{0,19},
         {0,18},{0,25},{0,15},{0,16},{0,17},{0,24},{0,22},{0,23},{1,1},{1,11},{1,2},{1,12},{1,3},{1,10},{1,6},{1,5},{1,20},{1,7},{1,4},{1,9},{1,8},
         {1,18},{1,13},{1,21},{1,25},{1,26},{1,23},{1,14},{1,17},{1,19},{1,22},{1,24},{1,15},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,16},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,0},{0,28},{0,1},{0,2},{0,12},{0,3},{1,0},{0,4},{0,11},{0,13},{0,9},{0,5},{0,8},{0,10},{0,7},{0,6},{0,21},{0,14},{0,27},{0,15},{0,22},
         {0,19},{0,16},{0,20},{0,17},{0,26},{0,18},{1,1},{0,25},{0,23},{0,24},{1,2},{1,12},{1,3},{1,4},{1,11},{1,13},{1,7},{1,5},{1,6},{1,8},{1,10},
         {1,9},{1,22},{1,14},{1,15},{1,20},{1,23},{1,17},{1,19},{1,25},{1,26},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{1,16},{1,18},{1,21},{1,24},{1,27},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
         {-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}},

        {{0,0},{0,1},{0,2},{0,3},{0,4},{0,5},{0,13},{0,6},{0,10},{0,7},{0,8},{0,12},{0,11},{0,9},{0,14},{0,15},{1,0},{0,29},{0,16},{0,30},{0,17},
         {0,31},{0,24},{0,32},{0,18},{0,25},{0,23},{1,1},{0,22},{0,33},{0,21},{0,19},{0,20},{0,26},{0,35},{0,42},{0,34},{0,27},{0,28},{0,41},{0,37},
         {1,2},{0,39},{0,38},{0,40},{0,36},{0,43},{1,3},{0,44},{1,13},{1,4},{0,47},{1,10},{0,45},{0,46},{1,9},{1,12},{1,5},{1,6},{1,8},{1,7},{0,48},
         {0,49},{1,11},{1,14},{0,53},{0,51},{0,50},{0,52},{0,57},{1,15},{0,56},{1,16},{0,54},{0,55},{1,24},{1,18},{1,17},{1,23},{1,22},{1,19},
         {1,21},{0,59},{1,25},{1,20},{1,26},{0,58},{1,27},{0,61},{1,32},{0,60},{1,28},{1,30},{1,33},{0,63},{1,29},{1,34},{1,39},{0,62},{1,35},
         {1,36},{1,38},{1,37},{1,41},{1,31},{1,40},{1,42},{1,43},{1,44},{1,45},{1,46},{1,47},{1,48},{1,49},{1,50},{1,51},{1,52},{1,53},{1,54},
         {1,55},{1,56},{1,57},{1,58},{1,59},{1,60},{1,61},{1,62}}
    };

static const int vlctable_8x8[28] = {8,0,0,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6};


const int zigzag4[16] = {
    0, 1, 5, 6,
    2, 4, 7,12,
    3, 8,11,13,
    9,10,14,15};

const int zigzag[64] = {
     0,  1,  5,  6, 14, 15, 27, 28,
     2,  4,  7, 13, 16, 26, 29, 42,
     3,  8, 12, 17, 25, 30, 41, 43,
     9, 11, 18, 24, 31, 40, 44, 53,
    10, 19, 23, 32, 39, 45, 52, 54,
    20, 22, 33, 38, 46, 51, 55, 60,
    21, 34, 37, 47, 50, 56, 59, 61,
    35, 36, 48, 49, 57, 58, 62, 63};

const int zigzag_svt[64] = {
    0, 1, 5, 6,13,14,21,22,29,30,37,38,45,46,53,54,
    2, 4, 7,12,15,20,23,28,31,36,39,44,47,52,55,60,
    3, 8,11,16,19,24,27,32,35,40,43,48,51,56,59,61,
    9,10,17,18,25,26,33,34,41,42,49,50,57,58,62,63};

//const int zigzag_svt[64] = {
//  0,  3,  6,  9, 12, 15, 18, 22, 24, 27, 30, 34, 39, 45, 48, 50,
//  1,  5,  7, 13, 16, 20, 23, 28, 31, 35, 38, 42, 49, 53, 55, 56,
//  2,  8, 11, 17, 19, 25, 29, 33, 36, 40, 43, 46, 52, 57, 58, 59,
//  4, 10, 14, 21, 26, 32, 37, 41, 44, 47, 51, 54, 60, 61, 62, 63
//};

//const int zigzag_svt[64] = {
//  0,  3,  6,  9, 13, 14, 18, 21, 22, 26, 29, 33, 39, 44, 47, 48,
//  1,  5,  8, 12, 15, 19, 23, 27, 31, 35, 38, 41, 50, 52, 55, 56,
//  2,  7, 11, 16, 20, 25, 30, 34, 36, 40, 43, 46, 53, 57, 58, 59,
//  4, 10, 17, 24, 28, 32, 37, 42, 45, 49, 51, 54, 60, 61, 62, 63
//};


int get_vlc(int n,stream *str)
{
    int cw,bit,zeroes=0,done=0,tmp;
    unsigned int val = 0;
    int first;
    unsigned int lead = 0;

    if (n < 5)
    {
        while (!done && zeroes < 6)
        {
            bit = getbits1(str);
            if (bit)
            {
                cw = getbits(str,n);
                done = 1;
            }
            else zeroes++;
        }
        if (done) val = (zeroes<<n)+cw;
        else
        {
            lead = n;
            while (!done)
            {
                first = showbits(str,1);
                if (!first)
                {
                    lead++;
                    flushbits(str,1);
                }
                else
                {
                    tmp = getbits(str,lead+1);
                    val = 6 * (1 << n) + tmp - (1 << n);
                    done = 1;
                }
            }
        }
    }
    else if (n < 8)
    {
        while (!done)
        {
            bit = getbits1(str);
            if (bit)
            {
                cw = getbits(str,(n-4));
                done = 1;
            }
            else zeroes++;
        }
        val = (zeroes<<(n-4))+cw;
    }
    else if (n == 8)
    {
        if (getbits1(str))
        {
            val = 0;
        }
        else if (getbits1(str))
        {
            val = 1;
        }
        else
        {
            val = 2;
        }
    }
    else if (n == 9)
    {
        if (getbits1(str))
        {
            if (getbits1(str))
            {
                val = getbits(str,3)+3;
            }
            else if (getbits1(str))
            {
                val = getbits1(str)+1;
            }
            else
            {
                val = 0;
            }
        }
        else
        {
            while (!done)
            {
                bit = getbits1(str);
                if (bit)
                {
                    cw = getbits(str,4);
                    done = 1;
                }
                else zeroes++;
            }
            val = (zeroes<<4)+cw+11;
        }
    }
    else if (n == 10)
    {
        while (!done)
        {
            first = showbits(str,1);
            if (!first)
            {
                lead++;
                flushbits(str,1);
            }
            else
            {
                val = getbits(str,lead+1)-1;
                done = 1;
            }
        }
    }
    else rferror("Illegal VLC table number. 0-10 allowed only.");
    return val;
}

int get_wlc(int n,stream *str)
{
    int cw,bit,zeroes=0,done=0,tmp;
    unsigned int val = 0;
    int first;
    unsigned int lead = 0;

    if (n < 5)
    {
        while (!done && zeroes < 6)
        {
            bit = getbits1(str);
            if (bit)
            {
                cw = getbits(str,n);
                done = 1;
            }
            else zeroes++;
        }
        if (done) val = (zeroes<<n)+cw;
        else
        {
            lead = n;
            while (!done)
            {
                first = showbits(str,1);
                if (!first)
                {
                    lead++;
                    flushbits(str,1);
                }
                else
                {
                    tmp = getbits(str,lead+1);
                    val = 6 * (1 << n) + tmp - (1 << n);
                    done = 1;
                }
            }
        }
    }
    else if (n == 5)
    {
        if (getbits1(str))
        {
            val = 0;
        }
        else if (getbits1(str))
        {
            val = 1;
        }
        else
        {
            val = 2;
        }
    }
    else if (n == 6)
    {
        if (getbits1(str))
        {
            val = 0;
        }
        else if (getbits1(str))
        {
            val = 1;
        }
        else if (getbits1(str))
        {
            val = 2;
        }
        else
        {
            val = 3;
        }
    }
    else if (n == 7)
    {
        if (getbits1(str))
        {
            val = 0;
        }
        else if (getbits1(str))
        {
            val = 1;
        }
        else if (getbits1(str))
        {
            val = 2;
        }
        else if (getbits1(str))
        {
            val = 3;
        }
        else
        {
            val = 4;
        }
    }
    else if (n == 40)
    {
        if (getbits1(str))
        {
            if (getbits1(str))
            {
                val = getbits(str,3)+3;
            }
            else if (getbits1(str))
            {
                val = getbits1(str)+1;
            }
            else
            {
                val = 0;
            }
        }
        else
        {
            while (!done)
            {
                bit = getbits1(str);
                if (bit)
                {
                    cw = getbits(str,4);
                    done = 1;
                }
                else zeroes++;
            }
            val = (zeroes<<4)+cw+11;
        }
    }
    else rferror("Illegal VLC table number. 0-7 and 40 allowed only.");
    return val;
}

int get_uvlc_new(stream *str)
{
    int done=0;
    int first;
    unsigned int lead = 0;
    unsigned int cn;

    while (!done)
    {
        first = showbits(str,1);
        if (!first)
        {
            lead++;
            flushbits(str,1);
        }
        else
        {
            cn = getbits(str,lead+1)-1;
            done = 1;
        }
    }
    return cn;
}

int get_level(stream *str)
{
    int code,sign,coeff;


    code = get_vlc(10,str);

    if (!(code%2))
    {
        sign = 0;
    }
    else
    {
        sign = 1;
        code++;
    }
    coeff = code>>1;
    if (sign) coeff = -coeff;
    return coeff;
}    

int get_4x4(decoder_info *decoderInfo,stream *str,int **tcoeff,int n)
{
    int i,j;
    int sign;
    int tmp;
    cstruct combo;
    int vlc,cn,this_pos;
    int maxrun;
    int last_position;
    int scoeff[16];
    int atable[5] = {4,6,14,28,0xfffffff};
    int vlc_adaptive=0;
    int done;


    //static const int switch_thr[8] = {49,49,0,49,49,0,49,49};

    //int sum_big_coef = 0;


    for (i = 0; i < 16; i++) scoeff[i] = 0;

    /* Get the last nonzero coeff */

    {
        int x,y,cx,cy,vlcNum,tmp;

        int vlcTable[8] = {2,2,2};


        /* Decode according to current LP table */
#if ADAPT_VLC_NUM0
        vlcNum = last_pos_vlcnum[n][IMIN(16,decoderInfo->currContext->last_pos_vlc_index[n])];
#else
        vlcNum = vlcTable[n];
#endif
        tmp = get_vlc(vlcNum,str);
        cn = decoderInfo->currContext->LPTableD4[n][tmp];
        combo.level = (cn>15);
        combo.last_pos = cn&0x0f;

        /* Adapt LP table */
        cx = tmp;
        cy = IMAX(0,cx-1);
        x = cn;
        y = decoderInfo->currContext->LPTableD4[n][cy];
        decoderInfo->currContext->LPTableD4[n][cy] = x;
        decoderInfo->currContext->LPTableD4[n][cx] = y;
        if (trace & 2)
            fprintf(tracefile, "last_pos = %d\n", combo.level*64 + combo.last_pos);
#if ADAPT_VLC_NUM0
        decoderInfo->currContext->last_pos_vlc_index[n] += cx == decoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < decoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);
#endif
    }
    
    if (combo.level == 1)
    {
        tmp = get_vlc(0,str);
        sign = tmp&1;
        tmp = (tmp>>1)+2;
        if (trace & 2)
            fprintf(tracefile, "level = %d\n", tmp);
    }
    else{
        tmp = 1;
        sign = getbits1(str);
        if (trace & 2)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    if (sign) tmp = -tmp;

    last_position = combo.last_pos;
    this_pos = 15-last_position;
    scoeff[this_pos] = tmp;
    i = this_pos;
    i++;

    done = 0;
    {
        while (!done && i < 16)
        {
            maxrun = 15-i;
            if (maxrun > 27)
            {
                maxrun = 28;
                vlc = 3;
            }
            else
            {
                vlc = vlctable_8x8[maxrun];
            }
            /* Go into run mode */
            cn = get_vlc(vlc,str);
            combo = luma_run_8x8[maxrun][cn];
            if (trace & 2)
                fprintf(tracefile, "lev,run = %d,%d\n", combo.level,combo.last_pos);
            i += combo.last_pos;
            /* No sign for last zeroes */
            if (i < 16)
            {
                if (combo.level == 1)
                {
                    tmp = get_vlc(0,str);
                    sign = tmp&1;
                    tmp = (tmp>>1)+2;
                    if (trace & 2)
                        fprintf(tracefile, "level = %d\n", tmp);

                    
                        done = 1;
                }
                else{
                    tmp = 1;
                    sign = getbits1(str);
                    if (trace & 2)
                        fprintf(tracefile, "sign = %d\n", sign);
                }
                if (sign) tmp = -tmp;
                scoeff[i] = tmp;
            }
            i++;
        }
    }
    if (i < 16)
    {
        /* Get the rest in level mode */
        while (i<16)
        {
            tmp = get_vlc(vlc_adaptive,str);
            if (trace & 2)
                fprintf(tracefile, "level = %d\n", tmp);

            if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
            if (tmp)
            {
                sign = getbits1(str);
                if (trace & 2)
                    fprintf(tracefile, "sign = %d\n", sign);
                if (sign) tmp = -tmp;
            }
            scoeff[i] = tmp;
            i++;
        }
    }
    for (i=0;i<4;i++){
        for (j=0;j<4;j++){
            tcoeff[i][j] = scoeff[15-(zigzag4[i*4+j])];
        }
    }
    return 0;
}

int get_8x8(decoder_info *decoderInfo,stream *str,int **tcoeff,int n)
{
    int i,j;
    int sign;
    int tmp;
    cstruct combo;
    int vlc,cn,this_pos;
    int maxrun;
    int last_position;
    int scoeff[64];
    int atable[5] = {4,6,14,28,0xfffffff};
    int vlc_adaptive=0;
    int done;

    static const int switch_thr[10] = {49,49,0,49,49,0,49,49,49,49};
    int sum_big_coef = 0;


    for (i = 0; i < 64; i++) scoeff[i] = 0;

    /* Get the last nonzero coeff */

    {
        int x,y,cx,cy,vlcNum,tmp;
        //int vlcTable[10] = {10,10,3,3,3,4,4,4,3,3};

        /* Decode according to current LP table */
        // ADAPT_VLC_NUM
        vlcNum = last_pos_vlcnum[n][IMIN(16,decoderInfo->currContext->last_pos_vlc_index[n])];
        // vlcNum = vlcTable[n];
        tmp = get_vlc(vlcNum,str);
        cn = decoderInfo->currContext->LPTableD[n][tmp];
        combo.level = (cn>63);
        combo.last_pos = cn&0x3f;

        /* Adapt LP table */
        cx = tmp;
        cy = IMAX(0,cx-1);
        x = cn;
        y = decoderInfo->currContext->LPTableD[n][cy];
        decoderInfo->currContext->LPTableD[n][cy] = x;
        decoderInfo->currContext->LPTableD[n][cx] = y;	
        if (trace & 2)
            fprintf(tracefile, "last_pos = %d\n", combo.level*64 + combo.last_pos);
        // ADAPT_VLC_NUM
        decoderInfo->currContext->last_pos_vlc_index[n] += cx == decoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < decoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);
    }
    
    if (combo.level == 1)
    {
        tmp = get_vlc(0,str);
        sign = tmp&1;
        tmp = (tmp>>1)+2;
        if (trace & 2)
            fprintf(tracefile, "level = %d\n", tmp);
    }
    else{
        tmp = 1;
        sign = getbits1(str);
        if (trace & 2)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    if (sign) tmp = -tmp;

    last_position = combo.last_pos;
    this_pos = 63-last_position;
    scoeff[this_pos] = tmp;
    i = this_pos;
    i++;

    done = 0;
    {
        while (!done && i < 64)
        {
            maxrun = 63-i;
            if (maxrun > 27)
            {
                maxrun = 28;
                vlc = 3;
            }
            else
            {
                vlc = vlctable_8x8[maxrun];
            }
            /* Go into run mode */
            cn = get_vlc(vlc,str);
            combo = luma_run_8x8[maxrun][cn];
            if (trace & 2)
                fprintf(tracefile, "lev,run = %d,%d\n", combo.level,combo.last_pos);
            i += combo.last_pos;
            /* No sign for last zeroes */
            if (i < 64)
            {
                if (combo.level == 1)
                {
                    tmp = get_vlc(0,str);
                    sign = tmp&1;
                    tmp = (tmp>>1)+2;
                    if (trace & 2)
                        fprintf(tracefile, "level = %d\n", tmp);

                    sum_big_coef += tmp;
                    if (i > switch_thr[n] || sum_big_coef > 2)
                        done = 1;
                }
                else{
                    tmp = 1;
                    sign = getbits1(str);
                    if (trace & 2)
                        fprintf(tracefile, "sign = %d\n", sign);
                }
                if (sign) tmp = -tmp;
                scoeff[i] = tmp;
            }
            i++;
        }
    }
    if (i < 64)
    {
        /* Get the rest in level mode */
        while (i<64)
        {
            tmp = get_vlc(vlc_adaptive,str);
            if (trace & 2)
                fprintf(tracefile, "level = %d\n", tmp);

            if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
            if (tmp)
            {
                sign = getbits1(str);
                if (trace & 2)
                    fprintf(tracefile, "sign = %d\n", sign);
                if (sign) tmp = -tmp;
            }
            scoeff[i] = tmp;
            i++;
        }
    }
    for (i=0;i<8;i++)
    {
        for (j=0;j<8;j++)
        {
            tcoeff[i][j] = scoeff[63-(zigzag[i*8+j])];
        }
    }
    return 0;
}

int get_8x8_svt(decoder_info *decoderInfo,stream *str,int **tcoeff,int n)
{
    int i,j;
    int sign;
    int tmp;
    cstruct combo;
    int vlc,cn,this_pos;
    int maxrun;
    int last_position;
    int scoeff[64];
    int atable[5] = {4,6,14,28,0xfffffff};
    int vlc_adaptive=0;
    int done;

    static const int switch_thr[10] = {49,49,0,49,49,0,49,49,49,49};
    int sum_big_coef = 0;


    for (i = 0; i < 64; i++) scoeff[i] = 0;

    /* Get the last nonzero coeff */

    {
        int x,y,cx,cy,vlcNum,tmp;
        //int vlcTable[10] = {10,10,3,3,3,4,4,4,3,3};
        /* Decode according to current LP table */
        // ADAPT_VLC_NUM
        vlcNum = last_pos_vlcnum[n][IMIN(16,decoderInfo->currContext->last_pos_vlc_index[n])];
        // vlcNum = vlcTable[n];
        tmp = get_vlc(vlcNum,str);
        cn = decoderInfo->currContext->LPTableD[n][tmp];
        combo.level = (cn>63);
        combo.last_pos = cn&0x3f;

        /* Adapt LP table */
        cx = tmp;
        cy = IMAX(0,cx-1);
        x = cn;
        y = decoderInfo->currContext->LPTableD[n][cy];
        decoderInfo->currContext->LPTableD[n][cy] = x;
        decoderInfo->currContext->LPTableD[n][cx] = y;	
        if (trace & 2)
            fprintf(tracefile, "last_pos = %d\n", combo.level*64 + combo.last_pos);
        // ADAPT_VLC_NUM
        decoderInfo->currContext->last_pos_vlc_index[n] += cx == decoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < decoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);
    }
    
    if (combo.level == 1)
    {
        tmp = get_vlc(0,str);
        sign = tmp&1;
        tmp = (tmp>>1)+2;
        if (trace & 2)
            fprintf(tracefile, "level = %d\n", tmp);
    }
    else{
        tmp = 1;
        sign = getbits1(str);
        if (trace & 2)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    if (sign) tmp = -tmp;

    last_position = combo.last_pos;
    this_pos = 63-last_position;
    scoeff[this_pos] = tmp;
    i = this_pos;
    i++;

    done = 0;
    {
        while (!done && i < 64)
        {
            maxrun = 63-i;
            if (maxrun > 27)
            {
                maxrun = 28;
                vlc = 3;
            }
            else
            {
                vlc = vlctable_8x8[maxrun];
            }
            /* Go into run mode */
            cn = get_vlc(vlc,str);
            combo = luma_run_8x8[maxrun][cn];
            if (trace & 2)
                fprintf(tracefile, "lev,run = %d,%d\n", combo.level,combo.last_pos);
            i += combo.last_pos;
            /* No sign for last zeroes */
            if (i < 64)
            {
                if (combo.level == 1)
                {
                    tmp = get_vlc(0,str);
                    sign = tmp&1;
                    tmp = (tmp>>1)+2;
                    if (trace & 2)
                        fprintf(tracefile, "level = %d\n", tmp);
                    sum_big_coef += tmp;
                    if (i > switch_thr[n] || sum_big_coef > 2)
                        done = 1;
                }
                else{
                    tmp = 1;
                    sign = getbits1(str);
                    if (trace & 2)
                        fprintf(tracefile, "sign = %d\n", sign);
                }
                if (sign) tmp = -tmp;
                scoeff[i] = tmp;
            }
            i++;
        }
    }
    if (i < 64)
    {
        /* Get the rest in level mode */
        while (i<64)
        {
            tmp = get_vlc(vlc_adaptive,str);
            if (trace & 2)
                fprintf(tracefile, "level = %d\n", tmp);

            if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
            if (tmp)
            {
                sign = getbits1(str);
                if (trace & 2)
                    fprintf(tracefile, "sign = %d\n", sign);
                if (sign) tmp = -tmp;
            }
            scoeff[i] = tmp;
            i++;
        }
    }
    for (i=0;i<4;i++)
    {
        for (j=0;j<16;j++)
        {
            tcoeff[i][j] = scoeff[63-(zigzag_svt[i*16+j])];
        }
    }
    return 0;
}

int decode_side_intra(stream *str,int chroma)
{
  int side_intra = get_wlc(chroma?1:3,str);
  int sign = getbits(str,1);
  if(sign == 1)
      side_intra = -1*side_intra;
  return side_intra;
}

/* int get_level_8x8(stream *str) */
/* { */
/*     int code,sign,coeff; */

/*     code = get_uvlc_new(str); */
/*     if (!(code%2)) */
/*     { */
/*         sign = 0; */
/*     } */
/*     else */
/*     { */
/*         sign = 1; */
/*         code++; */
/*     } */
/*     coeff = code>>1; */
/*     if (sign) coeff = -coeff; */
/*     return coeff; */
/* } */

/* int get_vlc(int n,stream *str) */
/* { */
/*     int cw,bit,zeroes=0,done=0; */
/*     unsigned int val = 0; */

/*     if (n < 3) */
/*     { */
/*     while (!done) */
/*     { */
/*         bit = getbits1(str); */
/*         if (bit) */
/*         { */
/*             cw = getbits(str,n); */
/*             done = 1; */
/*         } */
/*         else zeroes++; */
/*     } */
/*     val = (zeroes<<n)+cw; */
/*     } */
/*     else if (n == 3) */
/*     { */
/*         if (getbits1(str)) */
/*         { */
/*             val = 0; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 1; */
/*         } */
/*         else */
/*         { */
/*             val = 2; */
/*         } */
/*     } */
/*     else rferror("Illegal VLC table number. 0-3 allowed only."); */
/*     return val; */
/* } */

/* int get_vlc_8x8(int n,stream *str) */
/* { */
/*     int cw,bit,zeroes=0,done=0; */
/*     unsigned int val = 0; */

/*     if (n < 5) */
/*     { */
/*         while (!done) */
/*         { */
/*             bit = getbits1(str); */
/*             if (bit) */
/*             { */
/*                 cw = getbits(str,n); */
/*                 done = 1; */
/*             } */
/*             else zeroes++; */
/*         } */
/*         val = (zeroes<<n)+cw; */
/*     } */
/*     else if (n == 5) */
/*     { */
/*         if (getbits1(str)) */
/*         { */
/*             val = 0; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 1; */
/*         } */
/*         else */
/*         { */
/*             val = 2; */
/*         } */
/*     } */
/*     else if (n == 6) */
/*     { */
/*         if (getbits1(str)) */
/*         { */
/*             val = 0; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 1; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 2; */
/*         } */
/*         else */
/*         { */
/*             val = 3; */
/*         } */
/*     } */
/*     else if (n == 7) */
/*     { */
/*         if (getbits1(str)) */
/*         { */
/*             val = 0; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 1; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 2; */
/*         } */
/*         else if (getbits1(str)) */
/*         { */
/*             val = 3; */
/*         } */
/*         else */
/*         { */
/*             val = 4; */
/*         } */
/*     } */
/*     else if (n == 40) */
/*     { */
/*         if (getbits1(str)) */
/*         { */
/*             if (getbits1(str)) */
/*             { */
/*                 val = getbits(str,3)+3; */
/*             } */
/*             else if (getbits1(str)) */
/*             { */
/*                 val = getbits1(str)+1; */
/*             } */
/*             else */
/*             { */
/*                 val = 0; */
/*             } */
/*         } */
/*         else */
/*         { */
/*             while (!done) */
/*             { */
/*                 bit = getbits1(str); */
/*                 if (bit) */
/*                 { */
/*                     cw = getbits(str,4); */
/*                     done = 1; */
/*                 } */
/*                 else zeroes++; */
/*             } */
/*             val = (zeroes<<4)+cw+11; */
/*         } */
/*     } */
/*     else rferror("Illegal VLC table number. 0-7 and 40 allowed only."); */
/* /\*     fprintf(dbgfile,"vlc_8x8: cn = %d\n",val); *\/ */
/*     return val; */
/* } */

/* int get_uvlc(stream *str) */
/* { */
/*     int done=0,first,info=0,len=0; */

/*     while (!done) */
/*     { */
/*         first = getbits1(str); */
/*         if (first) done = 1; */
/*         else */
/*         { */
/*             info = (info << 1) | getbits1(str); */
/*             len++; */
/*         } */
/*     } */
/*     return (1<<len)+info-1; */
/* } */

/* int get_uvlc_8x8(stream *str) */
/* { */
/*     int done=0; */
/*     int first; */
/*     unsigned int lead = 0; */
/*     unsigned int cn; */

/*     while (!done) */
/*     { */
/*         first = showbits(str,1); */
/*         if (!first) */
/*         { */
/*             lead++; */
/*             flushbits(str,1); */
/*         } */
/*         else */
/*         { */
/*             if (lead == 0) */
/*             { */
/*                 cn = 0; */
/*             } */
/*             if (lead < 6) */
/*             { */
/*                 cn = lead*2; */
/*                 getbits1(str); */
/*                 if (!(getbits1(str))) */
/*                 { */
/*                     cn--; */
/*                 } */
/*             } */
/*             else */
/*             { */
/*                 cn = getbits(str,lead-4)-1; */
/*             } */
/*             done = 1; */
/*         } */
/*     } */
/*     return cn; */
/* } */

