/***************************************************************/
/* TENTM software accompanying JCTVC-A119                      */
/* Copyright Tandberg, Ericsson, Nokia, 2010                   */
/***************************************************************/



#if !defined(_GLOBAL_H_)
#define _GLOBAL_H_

#ifdef __INTEL_COMPILER
#define _aligned_free(a) _mm_free(a)
#define _aligned_malloc(a, b) _mm_malloc(a, b)
#define malloc(a) _mm_malloc(a,16)
#define free(a) _mm_free(a)
#define inline __forceinline
#else
#ifndef restrict
#define restrict
#endif
#define inline
#endif

#define mnint(a) ((a) < 0 ? (int)(a - 0.5) : (int)(a + 0.5))

#define CFP_CONFORMANCE     1

#if CFP_CONFORMANCE
#define NEW_PLANAR         0 // Fix for planar filtering and 16-pel processing
#else
#define NEW_PLANAR         1 // Fix for planar filtering and 16-pel processing
#endif

#define FAST_GETBITS       1
#define FAST_INTERPOLATE   1

#define DEBUG              0  // Disable trace and debug for distributing executable to VCEG
#define TRACE              0

#define LMBYSIZE 64
#define LMBXSIZE 64

#endif
