/***************************************************************/
/* TENTM software accompanying JCTVC-A119                      */
/* Copyright Tandberg, Ericsson, Nokia, 2010                   */
/***************************************************************/



#if !defined(_GLOBAL_H_)
#define _GLOBAL_H_

#include <stdlib.h>
#include <stdio.h>

#ifdef __INTEL_COMPILER
#define _aligned_free(a) _mm_free(a)
#define _aligned_malloc(a, b) _mm_malloc(a, b)
#define malloc(a) _mm_malloc(a,16)
#define free(a) _mm_free(a)
#define inline __forceinline
#else
#ifndef restrict
#define restrict
#endif
#define inline
#endif

static inline void fatalerror(char error_text[])
{
    fprintf(stderr,"Run-time error...\n");
    fprintf(stderr,"%s\n",error_text);
    fprintf(stderr,"...now exiting to system...\n");
    exit(1);
}

#if !WIN32 && !IA64
typedef long long __int64;
#endif

#define CLEAN            1

#define CFP_CONFORMANCE     1

#if CFP_CONFORMANCE
#define BUGFIX_ME          1 // candidateMVs copied from previous frame
#define NEW_PLANAR         0 // Fix for planar filtering and 16-pel processing
#define BUGFIX_SVT_INVTR1  1 // Special rounding if QP >= 36
#else
#define CAND_MV_INIT       1 // candidateMVs set to zero for each frame (to be implemented)
#define NEW_PLANAR         1 // Fix for planar filtering and 16-pel processing
#define BUGFIX_SVT_INVTR2  1 // Correct rounding if QP >= 36
#define SVT_SAD            1 // SVT when SAD criterion is used
#endif

#define DBG_PRED_ERROR      0 // Output quantized prediction error to "pred_error.yuv" file
#define DBG_UPSAMPLE        0 // Output upsampled reference frame to "upsample.yuv" file
#define DBG_COMPLEXITY      0 // Print out the complexity profile
#define EXTENDED_STATISTICS 0
#define VCEG                0 //Disable certain input parameters for distributing executable to VCEG

#define EDGE_THR            2 //CODE_PLANAR - related
#define DQP_FINAL		    3 //DQP of final frames

#define FAST_MODE        1 
#define FIXBUG_17032010  0

#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#endif

#endif
