/***************************************************************/
/* TENTM software accompanying JCTVC-A119                      */
/* Copyright Tandberg, Ericsson, Nokia, 2010                   */
/***************************************************************/



#include <assert.h>
#include <stdlib.h>
#include "global.h"
#include "putbits.h"
#include "putvlc.h"
//STATIC #include "rfutil.h"

extern int trace;
extern FILE *dbgfile;
extern FILE *tracefile;


// ADAPT_VLC_NUM
const int last_pos_vlcnum[10][17] =
{
    {10,10,10,10, 2,2,2,7,9,9,9,9,9,4,4,4,4},
    {10,10,10,10,10,2,9,9,9,9,9,9,9,4,4,4,4},
    { 2, 2, 2, 2, 2,7,7,7,7,7,7,7,7,7,4,4,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    {10, 1, 2, 2, 2,2,7,7,7,7,9,9,9,4,4,4,4},
    {10,10, 2, 2, 7,7,7,7,7,7,7,7,4,4,4,4,4},
    {10,10, 2, 2, 7,7,7,7,7,7,7,7,4,4,4,4,4},

    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4},
    { 2, 2, 2, 2, 7,7,7,7,7,7,7,7,7,7,7,7,4}
};


/*
static const unsigned int last_pos_table[2][64] =
    {
        {  0,  2,  1,  3,  6,  4, 12, 11, 10,  5,  7, 15, 19, 20, 14, 22, 33, 29, 23, 21,  9, 27, 39, 38, 30, 32, 26, 13, 17, 25, 28, 31, 36, 40, 43, 37, 50, 49, 44, 41, 35, 18,  8, 16, 34, 42, 45, 47, 48, 51, 54, 53, 46, 24, 52, 56, 58, 55, 61, 62, 59, 70, 71, 81},
        { 57, 63, 60, 68, 67, 65, 79, 85, 82, 69, 78, 88, 93, 91, 80, 84,110,104, 94, 95, 75, 74,111,106, 97,102,100, 76, 64, 86, 96, 98, 99,115,112, 73, 92,116,117,114,101, 83, 66, 72, 89,107,108,103, 87, 90,118,121,113, 77,109,119,122,105,123,124,120,125,126,127}
    };
*/
static const unsigned int luma_run_8x8[29][2][64] =
    {
        /* 0 */
        {
            {  1,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 1 */
        {
            {  2,  1,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  4,  3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 2 */
        {
            {  1,  3,  2,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  4,  6,  5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 3 */
        {
            {  2,  1,  3,  4,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  6,  5,  7,  8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 4 */
        {
            {  1,  5,  3,  2,  4,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  6, 10,  8,  7,  9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 5 */
        {
            {  1,  2,  6,  5,  3,  4,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  7,  8, 11, 10,  9, 12, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 6 */
        {
            {  2,  1,  3,  5,  4,  7,  6,  0, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  9,  8, 10, 12, 11, 13, 14, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 7 */
        {
            {  1,  5,  4,  2,  3,  6,  8,  7,  0, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  9, 13, 12, 10, 11, 14, 15, 16, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 8 */
        {
            {  1,  3,  8,  7,  5,  2,  4,  9,  6,  0, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 10, 12, 16, 15, 14, 11, 13, 18, 17, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        /* 9 */
        {
            {  1,  2,  5, 10,  9,  7,  3,  4, 11,  6,  0, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  8, 12, 15, 17, 18, 16, 13, 14, 20, 19, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  2,  1,  3,  4,  7,  8,  5,  6,  9, 11, 10,  0, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 13, 12, 14, 15, 17, 18, 16, 19, 20, 22, 21, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  4,  3,  2,  5,  7,  6,  8, 10, 11, 12,  9,  0, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 13, 17, 15, 14, 16, 19, 18, 20, 22, 23, 24, 21, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  6,  7,  5,  3,  4,  8,  9, 13, 11, 12, 10,  0, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 14, 16, 18, 21, 19, 15, 17, 20, 22, 26, 23, 24, 25, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  4,  8,  9,  7,  6,  3,  5, 12, 14, 13, 11, 10,  0, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 15, 16, 19, 21, 23, 22, 20, 17, 18, 26, 28, 27, 24, 25, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  3,  5,  9, 10,  8,  7,  4,  6, 13, 16, 15, 14, 12,  0,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 11, 17, 18, 20, 22, 24, 23, 26, 19, 21, 27, 30, 29, 25, 28, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  3,  4,  5,  8, 10,  7,  6,  9, 11, 13, 18, 15, 16, 12,
               0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 14, 17, 19, 20, 21, 23, 25, 24, 22, 26, 27, 29, 31, 28, 32, 30,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  3,  4,  2,  5,  6, 10,  9,  7,  8, 11, 12, 13, 16, 17, 18,
              14,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 15, 19, 22, 20, 21, 24, 26, 25, 23, 27, 32, 29, 28, 30, 33, 34,
              31, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  4,  7,  6,  3,  5,  8,  9, 10, 11, 18, 15, 13, 14, 17,
              19, 12,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 16, 21, 24, 25, 26, 20, 22, 27, 23, 28, 30, 35, 31, 29, 34, 33,
              36, 32, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  5,  7,  9, 10,  6,  3,  4,  8, 11, 17, 20, 18, 15, 13,
              14, 19, 12,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 16, 21, 24, 25, 29, 28, 27, 23, 22, 26, 31, 36, 34, 37, 33, 32,
              30, 38, 35, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  3,  5,  7,  9, 14, 12,  8,  6,  2,  4, 15, 18, 21, 20, 16,
              10, 11, 22, 13,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 17, 23, 25, 27, 29, 31, 33, 30, 26, 19, 24, 35, 37, 39, 40, 36,
              32, 28, 38, 34, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  0,  2,  4,  7, 10,  9, 16, 15, 14,  8,  3,  5, 17, 19, 22, 20,
              18, 11, 13, 21, 12,  1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  6, 23, 25, 29, 27, 31, 30, 34, 38, 32, 24, 26, 36, 82, 39, 37,
               83, 28, 33, 84, 35, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  2,  1,  3,  4,  5,  8,  9, 11, 13, 10,  6,  7, 12, 14, 21, 24,
              23, 18, 15, 19, 22, 16,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 20, 17, 25, 26, 27, 28, 31, 34, 35, 30, 29, 32, 33, 36, 37, 43,
              44, 38, 39, 40, 41, 42, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  5,  4,  2,  3,  6,  8,  7, 11, 12,  9, 10, 13, 14, 15, 18,
              22, 21, 17, 19, 20, 25, 16,  0, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 26, 28, 27, 23, 24, 29, 31, 32, 38, 34, 30, 33, 35, 37, 36, 43,
              44, 40, 41, 85, 42, 86, 39, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  4,  8,  6,  5,  2,  3,  7,  9, 12, 10, 11, 13, 16, 15, 14,
              18, 20, 21, 19, 23, 22, 25, 17,  0, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 24, 28, 33, 29, 31, 26, 27, 34, 35, 36, 32, 30, 37, 40, 38, 42,
              45, 47, 39, 43, 46, 41, 87, 44, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  0,  3,  7, 12, 10,  6,  5,  2,  4,  8,  9, 11, 13, 17, 24, 21,
              16, 15, 19, 20, 22, 25, 26, 23, 18,  1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 14, 28, 34, 36, 33, 35, 31, 27, 30, 29, 32, 37, 40, 46, 38, 44,
              39, 47, 48, 49, 45, 41, 42, 50, 43, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  0,  2,  5,  9, 13, 11, 10,  8,  6,  3,  4,  7, 12, 15, 19, 26,
              23, 20, 16, 14, 18, 22, 27, 24, 25, 21,  1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 17, 28, 31, 36, 35, 39, 37, 34, 33, 30, 29, 32, 38, 43, 86, 87,
              45, 46, 44, 41, 40, 88, 48, 89, 47, 42, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  1,  2,  4,  7, 11, 15, 12,  9, 10,  8,  5,  3,  6, 14, 16, 23,
              24, 25, 21, 20, 13, 19, 27, 28, 26, 22, 17,  0, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            { 18, 29, 31, 33, 39, 36, 35, 38, 41, 40, 34, 30, 32, 43, 48, 53,
              90, 49, 42, 50, 37, 44, 51, 47, 52, 45, 46, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  0,  2,  3,  5,  7, 11, 15, 14, 12, 10, 13,  8,  4,  9, 17, 19,
              22, 24, 26, 21, 23, 16, 20, 29, 30, 28, 25, 18,  1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
            {  6, 27, 31, 33, 34, 38, 39, 37, 40, 42, 41, 35, 32, 36, 44, 45,
              87, 48, 88, 49, 46, 89, 43, 47, 90, 50, 51, 91, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
              -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        },
        {
            {  0,  1,  2,  3,  4,  5,  7,  9, 10, 13,  8, 12, 11,  6, 14, 15,
              18, 20, 24, 31, 32, 30, 28, 26, 22, 25, 33, 37, 38, 17, 19, 21,
              23, 29, 36, 34, 45, 40, 43, 42, 44, 39, 35, 46, 48, 53, 54, 51,
              61, 62, 67, 66, 68, 65, 73, 74, 71, 69, 86, 82, 90, 88, 98, 94},
            { 16, 27, 41, 47, 50, 57, 58, 60, 59, 55, 52, 63, 56, 49, 64, 70,
              72, 77, 76, 80, 84, 81, 79, 78, 75, 83, 85, 87, 91, 95, 92,104,
              89, 93, 96, 99,100,102,101, 97,105,103,106,107,108,109,110,111,
             112,113,114,115,116,117,118,119,120,121,122,123,124,125,126, -1}
        }
    };

static const int vlctable_8x8[28] = {8,0,0,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6};

const int zigzag[64] = {
    0, 1, 5, 6,14,15,27,28,
    2, 4, 7,13,16,26,29,42,
   3, 8,12,17,25,30,41,43,
    9,11,18,24,31,40,44,53,
    10,19,23,32,39,45,52,54,
    20,22,33,38,46,51,55,60,
    21,34,37,47,50,56,59,61,
    35,36,48,49,57,58,62,63};

const int zigzag4[16] = {
    0, 1, 5, 6,
    2, 4, 7,12,
    3, 8,11,13,
    9,10,14,15};

const int zigzag_svt[64] = {
    0, 1, 5, 6,13,14,21,22,29,30,37,38,45,46,53,54,
    2, 4, 7,12,15,20,23,28,31,36,39,44,47,52,55,60,
    3, 8,11,16,19,24,27,32,35,40,43,48,51,56,59,61,
    9,10,17,18,25,26,33,34,41,42,49,50,57,58,62,63};

//const int zigzag_svt[64] = {
//  0,  3,  6,  9, 12, 15, 18, 22, 24, 27, 30, 34, 39, 45, 48, 50,
//  1,  5,  7, 13, 16, 20, 23, 28, 31, 35, 38, 42, 49, 53, 55, 56,
//  2,  8, 11, 17, 19, 25, 29, 33, 36, 40, 43, 46, 52, 57, 58, 59,
//  4, 10, 14, 21, 26, 32, 37, 41, 44, 47, 51, 54, 60, 61, 62, 63
//};

//const int zigzag_svt[64] = {
//  0,  3,  6,  9, 12, 14, 18, 21, 22, 26, 29, 33, 39, 44, 48, 47,
//  1,  5,  7, 13, 16, 20, 23, 27, 31, 35, 38, 41, 50, 52, 55, 56,
//  2,  8, 11, 17, 19, 25, 30, 34, 36, 40, 43, 46, 53, 57, 59, 58,
//  4, 10, 15, 24, 28, 32, 37, 42, 45, 49, 51, 54, 60, 61, 62, 63
//};

//const int zigzag_svt[64] = {
//  0,  3,  6,  9, 13, 14, 18, 21, 22, 26, 29, 33, 39, 44, 47, 48,
//  1,  5,  8, 12, 15, 19, 23, 27, 31, 35, 38, 41, 50, 52, 55, 56,
//  2,  7, 11, 16, 20, 25, 30, 34, 36, 40, 43, 46, 53, 57, 58, 59,
//  4, 10, 17, 24, 28, 32, 37, 42, 45, 49, 51, 54, 60, 61, 62, 63
//};



unsigned int leading_zeros(unsigned int code)
{
    unsigned int count = 0;
    int done = 0;

    if (code)
    {
        while (!done)
        {
            code >>= 1;
            if (!code) done = 1;
            else count++;
        }
    }
    return count;
}

int put_vlc_8x8(unsigned int n,unsigned int cn,stream *str)
{
    unsigned int len,tmp;
    unsigned int code;

    if (n < 5)
    {
        tmp = 1<<n;
        code = tmp+cn%tmp;
        len = 1+n+(cn>>n);
    }
    else if (n == 5)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 0;
            len = 2;
        }
        else 
            fatalerror("Code number too large for VLC5.");
    }
    else if (n == 6)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 1;
            len = 3;
        }
        else if (cn == 3)
        {
            code = 0;
            len = 3;
        }
        else fatalerror("Code number too large for VLC6.");
    }
    else if (n == 7)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 1;
            len = 3;
        }
        else if (cn == 3)
        {
            code = 1;
            len = 4;
        }
        else if (cn == 4)
        {
            code = 0;
            len = 4;
        }
        else fatalerror("Code number too large for VLC7.");
    }
    else if (n == 40)
    {
        if (cn == 0)
        {
            code = 4;
            len = 3;
        }
        else if (cn == 1)
        {
            code = 10;
            len = 4;
        }
        else if (cn == 2)
        {
            code = 11;
            len = 4;
        }
        else if (cn < 11)
        {
            code = cn+21;
            len = 5;
        }
        else
        {
            tmp = 1<<4;
            code = tmp+(cn+5)%tmp;
            len = 5+((cn+5)>>4);
        }            
    }
    else fatalerror("No such VLC table, only 0-7 and 40 allowed.");
    putbits(len,code,str);
    return len;
}

int put_wlc(unsigned int n,unsigned int cn,stream *str)
{
    unsigned int len,tmp;
    unsigned int code;

    if (n < 5)
    {
        if ((int)cn < (6 * (1 << n)))
        {
            tmp = 1<<n;
            code = tmp+cn%tmp;
            len = 1+n+(cn>>n);
        }
        else
        {
            code = cn - (6 * (1 << n)) + (1 << n);
            len = (6-n)+1+2*leading_zeros(code);
        }
    }
    else if (n == 5)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 0;
            len = 2;
        }
        else fatalerror("Code number too large for VLC5.");
    }
    else if (n == 6)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 1;
            len = 3;
        }
        else if (cn == 3)
        {
            code = 0;
            len = 3;
        }
        else fatalerror("Code number too large for VLC6.");
    }
    else if (n == 7)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 1;
            len = 3;
        }
        else if (cn == 3)
        {
            code = 1;
            len = 4;
        }
        else if (cn == 4)
        {
            code = 0;
            len = 4;
        }
        else fatalerror("Code number too large for VLC7.");
    }
    else if (n == 40)
    {
        if (cn == 0)
        {
            code = 4;
            len = 3;
        }
        else if (cn == 1)
        {
            code = 10;
            len = 4;
        }
        else if (cn == 2)
        {
            code = 11;
            len = 4;
        }
        else if (cn < 11)
        {
            code = cn+21;
            len = 5;
        }
        else
        {
            tmp = 1<<4;
            code = tmp+(cn+5)%tmp;
            len = 5+((cn+5)>>4);
        }            
    }
    else fatalerror("No such VLC table, only 0-7 and 40 allowed.");
    putbits(len,code,str);
    return len;
}


int put_vlc(unsigned int n,unsigned int cn,stream *str)
{
    unsigned int len,tmp;
    unsigned int code;

    if (n < 5)
    {
        if ((int)cn < (6 * (1 << n)))
        {
            tmp = 1<<n;
            code = tmp+cn%tmp;
            len = 1+n+(cn>>n);
        }
        else
        {
            code = cn - (6 * (1 << n)) + (1 << n);
            len = (6-n)+1+2*leading_zeros(code);
        }
    }
    else if (n < 8)
    {
        tmp = 1<<(n-4);
        code = tmp+cn%tmp;
        len = 1+(n-4)+(cn>>(n-4));
    }
    else if (n == 8)
    {
        if (cn == 0)
        {
            code = 1;
            len = 1;
        }
        else if (cn == 1)
        {
            code = 1;
            len = 2;
        }
        else if (cn == 2)
        {
            code = 0;
            len = 2;
        }
        else fatalerror("Code number too large for VLC8.");
    }
    else if (n == 9)
    {
        if (cn == 0)
        {
            code = 4;
            len = 3;
        }
        else if (cn == 1)
        {
            code = 10;
            len = 4;
        }
        else if (cn == 2)
        {
            code = 11;
            len = 4;
        }
        else if (cn < 11)
        {
            code = cn+21;
            len = 5;
        }
        else
        {
            tmp = 1<<4;
            code = tmp+(cn+5)%tmp;
            len = 5+((cn+5)>>4);
        }            
    }
    else if (n == 10)
    {
        code = cn+1;
        len = 1+2*leading_zeros(code);
    }
    else fatalerror("No such VLC table, only 0-10 allowed.");
    putbits(len,code,str);
    return len;
}

int bitCount(encoder_info *encoderInfo,int k,int pos,int n,int lpflag,int levelMode,int run,int maxrun,int vlc_adaptive){
    int cn,vlc,x,cx,vlcNum,bits,temp;
    static const int vlcTable[8] = {10,10,3,3,3,4,4,4};
    static const int VLClength[11][128] = {
        { 1, 2, 3, 4, 5, 6, 7, 9, 9,11,11,11,11,13,13,13,13,13,13,13,13,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19},
        { 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8,10,10,10,10,12,12,12,12,12,12,12,12,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18},
        { 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
        { 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16},
        { 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13},
        { 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,30,30,31,31,32,32,33,33,34,34,35,35,36,36,37,37,38,38,39,39,40,40,41,41,42,42,43,43,44,44,45,45,46,46,47,47,48,48,49,49,50,50,51,51,52,52,53,53,54,54,55,55,56,56,57,57,58,58,59,59,60,60,61,61,62,62,63,63,64,64,65,65},
        { 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,22,22,22,22,23,23,23,23,24,24,24,24,25,25,25,25,26,26,26,26,27,27,27,27,28,28,28,28,29,29,29,29,30,30,30,30,31,31,31,31,32,32,32,32,33,33,33,33,34,34,34,34},
        { 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19},
        { 1, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 3, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13},
        { 1, 3, 3, 5, 5, 5, 5, 7, 7, 7, 7, 7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,15}
    };
    int sign = k<0 ? 1 : 0;
    k = abs(k);

    if (k){
        if (lpflag==1){                       
            x = pos + (k==1 ? 0 : 64);
            cx = encoderInfo->currContext->LPTableE[n][x];
            vlcNum = vlcTable[n];
                       
            bits = VLClength[vlcNum][cx];
            if (k>1) 
            {
                temp = 2*(k-2)+sign;
                if(temp > 127)
                    temp = 127;
                bits += VLClength[0][temp];
            }
            else
              bits += 1;                                     
        }
        else{
            if (!levelMode){                                                    
                cn = luma_run_8x8[min(maxrun,28)][k>1 ? 1 : 0][run];
                vlc = (maxrun>27) ? 3 : vlctable_8x8[maxrun];
                
                bits = VLClength[vlc][cn];
                if (k>1) 
                {
                    temp = 2*(k-2)+sign;
                    if(temp > 127)
                        temp = 127;
                    bits += VLClength[0][temp];
                }
                else
                    bits += 1;  
                               
            }
            else{
                if(k > 127)
                    k = 127;
                bits = VLClength[vlc_adaptive][k] + 1;
            }
        }
    }
    else{
        if (levelMode)
            bits = VLClength[vlc_adaptive][k];
        else{                        
            if (pos==0 && lpflag==0){  
                cn = luma_run_8x8[min(maxrun,28)][0][run+1];
                vlc = (maxrun>27) ? 3 : vlctable_8x8[maxrun];
                bits = VLClength[vlc][cn];
            }
            else
                bits = 0;
        }
    }
    return bits;
}



unsigned int quote_uvlc(unsigned int cn)
{
    unsigned int code = cn+1;
    unsigned int len = 1+2*leading_zeros(code);

    return len;
}

unsigned int put_uvlc(unsigned int cn,stream *str)
{
    unsigned int code = cn+1;
    unsigned int len = 1+2*leading_zeros(code);

    putbits(len,code,str);
/*     fprintf(dbgfile,"put_uvlc(): wrote %d\n",cn); */
    return len;
}

unsigned int quote_level(int level)
{
    int cn = abs(level)*2;

    if (level < 0) cn--;
    return quote_uvlc(cn);
}

unsigned int put_level(int level,stream *str)
{
    int cn = abs(level)*2;

    if (level < 0) cn--;
    return put_vlc(10,cn,str);
}    

/* Encode and write the coefficients of an 8x8 block to bitstream */

int encode_coeffs(encoder_info *encoderInfo,short coeff[8][8], stream *str,int *bits,int n,int adaptflag)
{
    int i,j;
    unsigned int len;
    unsigned int cn;
    int level,vlc,sign,done,last_pos,start;
    int run_done,maxrun,run,lev;
    int scoeff[64];
    int tmprun,vlc_adaptive=0;
    static const int atable[5] = {4,6,14,28,0xfffffff};
    int tmp;

    static const int switch_thr[10] = {49,49,0,49,49,0,49,49,49,49};
    int sum_big_coef = 0;


    /* Scan */
    for (i=0;i<8;i++)
    {
        for (j=0;j<8;j++)
        {
            scoeff[63-(zigzag[i*8+j])] = coeff[i][j];
        }
    }
    /* Do the last coefficient first */
    i = 0;
    done = 0;
    while (!done && i < 64)
    {
        if (scoeff[i])
        {
            done = 1;
        }
        else
        {
            i++;
        }
    }
    if (i == 64) 
      fatalerror("No coeffs even if cbp8 flagged it. Exiting.");
    last_pos = 63-i;
    level = abs(scoeff[i]);
    lev = (level == 1) ? 0 : 1;

    {
        int x,y,cx,cy,vlcNum;
        //int vlcTable[10] = {10,10,3,3,3,4,4,4,3,3};
        x = 64*lev + last_pos;
        cx = encoderInfo->currContext->LPTableE[n][x];
        // ADAPT_VLC_NUM
        vlcNum = last_pos_vlcnum[n][min(16,encoderInfo->currContext->last_pos_vlc_index[n])];
        // vlcNum = vlcTable[n];
        len = put_vlc(vlcNum,cx,str);
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "last_pos = %d\n", x);
        if (adaptflag){			
            // ADAPT_VLC_NUM
            encoderInfo->currContext->last_pos_vlc_index[n] += cx == encoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < encoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);

            cy = max(0,cx-1);
            y = encoderInfo->currContext->LPTableD[n][cy];
            encoderInfo->currContext->LPTableD[n][cy] = x;
            encoderInfo->currContext->LPTableD[n][cx] = y;
            encoderInfo->currContext->LPTableE[n][x] = cy;
            encoderInfo->currContext->LPTableE[n][y] = cx;
        }					
    }
    (*bits) += len;

    sign = (scoeff[i] < 0) ? 1 : 0;
    if (level > 1){
        len = put_vlc(0,2*(level-2)+sign,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", level);
    }
    else{
        putbits(1,sign,str);
        (*bits)++;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    i++;

    if (i < 64)
    {
        /* Go into run mode */
        run_done = 0;
        while (!run_done)
        {
            maxrun = 63-i;
            tmprun = maxrun;
            if (maxrun > 27)
            {
                vlc = 3;
                tmprun = 28;
            }
            else vlc = vlctable_8x8[maxrun];
            run = 0;
            done = 0;
            while (!done)
            {
                if (!scoeff[i])
                {
                    run++;
                }
                else
                {
                    level = abs(scoeff[i]);
                    lev = (level == 1) ? 0 : 1;
                    if (maxrun > 27)
                    {
                        cn = luma_run_8x8[28][lev][run];
                    }
                    else
                    {
                        cn = luma_run_8x8[maxrun][lev][run];
                    }
                    len = put_vlc(vlc,cn,str);
                    (*bits) += len;
                    if ((trace & 2) && str->outfile)
                        fprintf(tracefile, "lev,run = %d,%d\n", lev,run);

                    sign = (scoeff[i] < 0) ? 1 : 0;
                    if (level > 1){                        
                        len = put_vlc(0,2*(level-2)+sign,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "level = %d\n", level);

                        sum_big_coef += level;
                        if (i > switch_thr[n] || sum_big_coef > 2)
                            run_done = 1;
                    }
                    else{                        
                        putbits(1,sign,str);
                        (*bits)++;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "sign = %d\n", sign);
                    }

                    run = 0;
                    done = 1;
                }
                if (i == 63)
                {
                    done = 1;
                    run_done = 1;
                    if (run)
                    {
                        if (maxrun > 27)
                        {
                            cn = luma_run_8x8[28][0][run]; 
                        }
                        else
                        {
                            cn = luma_run_8x8[maxrun][0][run];
                        }
                        len = put_vlc(vlc,cn,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "lev,run = %d,%d\n", 0,run);
                    }
                }
                i++;
            }
        }
    }
    /* Code the rest in level mode */
    start = i;
    for (i=start;i<64;i++)
    {
        tmp = abs(scoeff[i]);
        len = put_vlc(vlc_adaptive,tmp,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", tmp);
        if (scoeff[i])
        {
            sign = (scoeff[i] < 0) ? 1 : 0;
            putbits(1,sign,str);
            (*bits)++;
            if ((trace & 2) && str->outfile)
                fprintf(tracefile, "sign = %d\n", sign);
        }
        if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
    }

    return 0;
}

int bitCountN(encoder_info *encoderInfo,int k,int pos,int n,int lpflag,int levelMode,int run,int maxrun,int vlc_adaptive,int N){
    int cn,vlc,x,cx,vlcNum,bits,temp;
    static const int vlcTable8[8] = {10,10,3,3,3,4,4,4}; // U,V,Y8x8I,Y8x8P,Y8x8B,Y16x16I,Y16x16P,Y16x16B
    static const int vlcTable4[3] = {2,2,2};             // Y4x4I,Y4x4P,Y4x4B,
    static const int VLClength[11][128] = {
        { 1, 2, 3, 4, 5, 6, 7, 9, 9,11,11,11,11,13,13,13,13,13,13,13,13,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19},
        { 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8,10,10,10,10,12,12,12,12,12,12,12,12,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18},
        { 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
        { 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16},
        { 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13},
        { 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,30,30,31,31,32,32,33,33,34,34,35,35,36,36,37,37,38,38,39,39,40,40,41,41,42,42,43,43,44,44,45,45,46,46,47,47,48,48,49,49,50,50,51,51,52,52,53,53,54,54,55,55,56,56,57,57,58,58,59,59,60,60,61,61,62,62,63,63,64,64,65,65},
        { 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,22,22,22,22,23,23,23,23,24,24,24,24,25,25,25,25,26,26,26,26,27,27,27,27,28,28,28,28,29,29,29,29,30,30,30,30,31,31,31,31,32,32,32,32,33,33,33,33,34,34,34,34},
        { 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19},
        { 1, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 3, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13},
        { 1, 3, 3, 5, 5, 5, 5, 7, 7, 7, 7, 7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,15}
    };
    int sign = k<0 ? 1 : 0;
    k = abs(k);
    if (N != 4 && N!= 8)
        fatalerror("unsupported block size in bitCountN()");
    if (k){
        if (lpflag==1){                       
            x = pos + (k==1 ? 0 : N*N);
            if (N==8){
                cx = encoderInfo->currContext->LPTableE[n][x];
                vlcNum = vlcTable8[n];
            }
            else if(N==4){
                cx = encoderInfo->currContext->LPTableE4[n][x];
                vlcNum = vlcTable4[n];
            }
            bits = VLClength[vlcNum][cx];
            if (k>1)
            {
                temp = 2*(k-2)+sign;
                if(temp > 127)
                    temp = 127;
                bits += VLClength[0][temp];
            }
            else bits += 1;                                     
        }
        else{
            if (!levelMode){                                                    
                cn = luma_run_8x8[min(maxrun,28)][k>1 ? 1 : 0][run];
                vlc = (maxrun>27) ? 3 : vlctable_8x8[maxrun];
                
                bits = VLClength[vlc][cn];
                if (k>1)
                {
                    temp = 2*(k-2)+sign;
                    if(temp > 127)
                        temp = 127;
                    bits += VLClength[0][temp];
                }
                else
                    bits += 1;  
                               
            }
            else{
                if(k > 127)
                    k = 127;
                bits = VLClength[vlc_adaptive][k] + 1;
            }
        }
    }
    else{
        if (levelMode)
            bits = VLClength[vlc_adaptive][k];
        else{                        
            if (pos==0 && lpflag==0){  
                cn = luma_run_8x8[min(maxrun,28)][0][run+1];
                vlc = (maxrun>27) ? 3 : vlctable_8x8[maxrun];
                bits = VLClength[vlc][cn];
            }
            else
                bits = 0;
        }
    }
    return bits;
}

int encode_coeffs4(encoder_info *encoderInfo,short coeff[8][8], stream *str,int *bits,int n,int adaptflag)
{
    int i,j;
    unsigned int len;
    unsigned int cn;
    int level,vlc,sign,done,last_pos,start;
    int run_done,maxrun,run,lev;
    int scoeff[16];
    int tmprun,vlc_adaptive=0;
    static const int atable[5] = {4,6,14,28,0xfffffff};
    int tmp;

    //static const int switch_thr[8] = {49,49,0,49,49,0,49,49};

    //int sum_big_coef = 0;


    /* Scan */
    for (i=0;i<4;i++){
        for (j=0;j<4;j++){
            scoeff[15-(zigzag4[i*4+j])] = coeff[i][j];
        }
    }
    /* Do the last coefficient first */
    i = 0;
    done = 0;
    while (!done && i < 16)
    {
        if (scoeff[i])
        {
            done = 1;
        }
        else
        {
            i++;
        }
    }
    if (i == 16) 
      fatalerror("No coeffs even if cbp4 flagged it. Exiting.");
    last_pos = 15-i;
    level = abs(scoeff[i]);
    lev = (level == 1) ? 0 : 1;

    {
        int x,y,cx,cy,vlcNum;

        int vlcTable[3] = {2,2,2};

        x = 16*lev + last_pos;
        cx = encoderInfo->currContext->LPTableE4[n][x];
#if ADAPT_VLC_NUM0
        vlcNum = last_pos_vlcnum[n][min(16,encoderInfo->currContext->last_pos_vlc_index[n])];
#else
        vlcNum = vlcTable[n];
#endif
        len = put_vlc(vlcNum,cx,str);
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "last_pos = %d\n", x);
        if (adaptflag){			
#if ADAPT_VLC_NUM0
            encoderInfo->currContext->last_pos_vlc_index[n] += cx == encoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < encoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);
#endif
            cy = max(0,cx-1);
            y = encoderInfo->currContext->LPTableD4[n][cy];
            encoderInfo->currContext->LPTableD4[n][cy] = x;
            encoderInfo->currContext->LPTableD4[n][cx] = y;
            encoderInfo->currContext->LPTableE4[n][x] = cy;
            encoderInfo->currContext->LPTableE4[n][y] = cx;
        }					
    }
    (*bits) += len;

    sign = (scoeff[i] < 0) ? 1 : 0;
    if (level > 1){
        len = put_vlc(0,2*(level-2)+sign,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", level);
    }
    else{
        putbits(1,sign,str);
        (*bits)++;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    i++;

    if (i < 16)
    {
        /* Go into run mode */
        run_done = 0;
        while (!run_done)
        {
            maxrun = 15-i;
            tmprun = maxrun;
            if (maxrun > 27)
            {
                vlc = 3;
                tmprun = 28;
            }
            else vlc = vlctable_8x8[maxrun];
            run = 0;
            done = 0;
            while (!done)
            {
                if (!scoeff[i])
                {
                    run++;
                }
                else
                {
                    level = abs(scoeff[i]);
                    lev = (level == 1) ? 0 : 1;
                    if (maxrun > 27)
                    {
                        cn = luma_run_8x8[28][lev][run];
                    }
                    else
                    {
                        cn = luma_run_8x8[maxrun][lev][run];
                    }
                    len = put_vlc(vlc,cn,str);
                    (*bits) += len;
                    if ((trace & 2) && str->outfile)
                        fprintf(tracefile, "lev,run = %d,%d\n", lev,run);

                    sign = (scoeff[i] < 0) ? 1 : 0;
                    if (level > 1){                        
                        len = put_vlc(0,2*(level-2)+sign,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "level = %d\n", level);
                        
                            run_done = 1;
                    }
                    else{                        
                        putbits(1,sign,str);
                        (*bits)++;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "sign = %d\n", sign);
                    }

                    run = 0;
                    done = 1;
                }                
                if (i == 15)
                {
                    done = 1;
                    run_done = 1;
                    if (run)
                    {
                        if (maxrun > 27)
                        {
                            cn = luma_run_8x8[28][0][run]; 
                        }
                        else
                        {
                            cn = luma_run_8x8[maxrun][0][run];
                        }
                        len = put_vlc(vlc,cn,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "lev,run = %d,%d\n", 0,run);
                    }
                }
                i++;
            }
        }
    }
    /* Code the rest in level mode */
    start = i;
    for (i=start;i<16;i++)
    {
        tmp = abs(scoeff[i]);
        len = put_vlc(vlc_adaptive,tmp,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", tmp);
        if (scoeff[i])
        {
            sign = (scoeff[i] < 0) ? 1 : 0;
            putbits(1,sign,str);
            (*bits)++;
            if ((trace & 2) && str->outfile)
                fprintf(tracefile, "sign = %d\n", sign);
        }
        if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
    }

    return 0;
}


int encode_coeffs_svt(encoder_info *encoderInfo,int coeff[4][16], stream *str,int *bits,int n,int adaptflag)
{
    int i,j;
    unsigned int len;
    unsigned int cn;
    int level,vlc,sign,done,last_pos,start;
    int run_done,maxrun,run,lev;
    int scoeff[64];
    int tmprun,vlc_adaptive=0;
    static const int atable[5] = {4,6,14,28,0xfffffff};
    int tmp;

    static const int switch_thr[10] = {49,49,0,49,49,0,49,49,49,49};
    int sum_big_coef = 0;


    /* Scan */
    for (i=0;i<4;i++)
    {
        for (j=0;j<16;j++)
        {
            scoeff[63-(zigzag_svt[i*16+j])] = coeff[i][j];
        }
    }
    /* Do the last coefficient first */
    i = 0;
    done = 0;
    while (!done && i < 64)
    {
        if (scoeff[i])
        {
            done = 1;
        }
        else
        {
            i++;
        }
    }
    if (i == 64) 
      fatalerror("No coeffs even if cbp flagged it. Exiting.");
    last_pos = 63-i;
    level = abs(scoeff[i]);
    lev = (level == 1) ? 0 : 1;

    {
        int x,y,cx,cy,vlcNum;
        //int vlcTable[10] = {10,10,3,3,3,4,4,4,3,3};
        x = 64*lev + last_pos;
        cx = encoderInfo->currContext->LPTableE[n][x];
        // ADAPT_VLC_NUM
        vlcNum = last_pos_vlcnum[n][min(16,encoderInfo->currContext->last_pos_vlc_index[n])];
        // vlcNum = vlcTable[n];
        len = put_vlc(vlcNum,cx,str);
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "last_pos = %d\n", x);
        if (adaptflag){			
            // ADAPT_VLC_NUM
            encoderInfo->currContext->last_pos_vlc_index[n] += cx == encoderInfo->currContext->last_pos_vlc_index[n] ? 0 : (cx < encoderInfo->currContext->last_pos_vlc_index[n] ? -1 : 1);

            cy = max(0,cx-1);
            y = encoderInfo->currContext->LPTableD[n][cy];
            encoderInfo->currContext->LPTableD[n][cy] = x;
            encoderInfo->currContext->LPTableD[n][cx] = y;
            encoderInfo->currContext->LPTableE[n][x] = cy;
            encoderInfo->currContext->LPTableE[n][y] = cx;
        }					
    }
    (*bits) += len;

    sign = (scoeff[i] < 0) ? 1 : 0;
    if (level > 1){
        len = put_vlc(0,2*(level-2)+sign,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", level);
    }
    else{
        putbits(1,sign,str);
        (*bits)++;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "sign = %d\n", sign);
    }
    i++;

    if (i < 64)
    {
        /* Go into run mode */
        run_done = 0;
        while (!run_done)
        {
            maxrun = 63-i;
            tmprun = maxrun;
            if (maxrun > 27)
            {
                vlc = 3;
                tmprun = 28;
            }
            else vlc = vlctable_8x8[maxrun];
            run = 0;
            done = 0;
            while (!done)
            {
                if (!scoeff[i])
                {
                    run++;
                }
                else
                {
                    level = abs(scoeff[i]);
                    lev = (level == 1) ? 0 : 1;
                    if (maxrun > 27)
                    {
                        cn = luma_run_8x8[28][lev][run];
                    }
                    else
                    {
                        cn = luma_run_8x8[maxrun][lev][run];
                    }
                    len = put_vlc(vlc,cn,str);
                    (*bits) += len;
                    if ((trace & 2) && str->outfile)
                        fprintf(tracefile, "lev,run = %d,%d\n", lev,run);

                    sign = (scoeff[i] < 0) ? 1 : 0;
                    if (level > 1){                        
                        len = put_vlc(0,2*(level-2)+sign,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "level = %d\n", level);

                        sum_big_coef += level;
                        if (i > switch_thr[n] || sum_big_coef > 2)
                            run_done = 1;
                    }
                    else{                        
                        putbits(1,sign,str);
                        (*bits)++;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "sign = %d\n", sign);
                    }

                    run = 0;
                    done = 1;
                }
                if (i == 63)
                {
                    done = 1;
                    run_done = 1;
                    if (run)
                    {
                        if (maxrun > 27)
                        {
                            cn = luma_run_8x8[28][0][run]; 
                        }
                        else
                        {
                            cn = luma_run_8x8[maxrun][0][run];
                        }
                        len = put_vlc(vlc,cn,str);
                        (*bits) += len;
                        if ((trace & 2) && str->outfile)
                            fprintf(tracefile, "lev,run = %d,%d\n", 0,run);
                    }
                }
                i++;
            }
        }
    }
    /* Code the rest in level mode */
    start = i;
    for (i=start;i<64;i++)
    {
        tmp = abs(scoeff[i]);
        len = put_vlc(vlc_adaptive,tmp,str);
        (*bits) += len;
        if ((trace & 2) && str->outfile)
            fprintf(tracefile, "level = %d\n", tmp);
        if (scoeff[i])
        {
            sign = (scoeff[i] < 0) ? 1 : 0;
            putbits(1,sign,str);
            (*bits)++;
            if ((trace & 2) && str->outfile)
                fprintf(tracefile, "sign = %d\n", sign);
        }
        if (tmp>atable[vlc_adaptive]) vlc_adaptive++;
    }

    return 0;
}

int encode_side_intra(int side_intra, stream *str,int *bits,int chroma)
{
  int len,tmp,sign;
  len = 0;
  tmp = abs(side_intra);
  
  if(chroma)
    len = put_wlc(1,tmp,str);
  else    
    len = put_wlc(3,tmp,str);
  
  sign = (side_intra < 0) ? 1 : 0;
  putbits(1,sign,str);
 
  *bits += len+1;

  return 0;       
}

