/***************************************************************/
/* TENTM software accompanying JCTVC-A119                      */
/* Copyright Tandberg, Ericsson, Nokia, 2010                   */
/***************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
//#include "global.h"
#include "snr.h"


extern FILE *dbgfile;


int snr(snrvals *psnr,image_frame *f1,image_frame *f2,int rows,int cols)
{
    unsigned int ydim,ydim_chr;
    unsigned int i,j,xdim,xdim_chr;
    double sumsqr=0;
    int ival;
    double plse;


    xdim = cols;
    xdim_chr = xdim >> 1;
    ydim = rows;
    ydim_chr = ydim >> 1;

    /* Calculate psnr for Y component */
    sumsqr = 0;
    for (i = 0; i < ydim; i++)
    {
        for (j = 0; j < xdim; j++)
        {
            ival = abs(f1->Y[i][j] - f2->Y[i][j]);
            sumsqr += (float)(ival * ival);
        }
    }
    plse = sumsqr / (65025.0 * ydim * xdim);
    psnr->y = -10 * log10(plse);
    /* Calculate psnr for U component */
    sumsqr = 0;
    for (i = 0; i < ydim_chr; i++)
    {
        for (j = 0; j < xdim_chr; j++)
        {
            ival = abs(f1->U[i][j] - f2->U[i][j]);
            sumsqr += (ival * ival);
        }
    }
    plse = sumsqr / (65025.0 * ydim_chr * xdim_chr);
    psnr->u = -10 * log10(plse);
    /* Calculate psnr for V component */
    sumsqr = 0;
    for (i = 0; i < ydim_chr; i++)
    {
        for (j = 0; j < xdim_chr; j++)
        {
            ival = abs(f1->V[i][j] - f2->V[i][j]);
            sumsqr += (ival * ival);
        }
    }
    plse = sumsqr / (65025.0 * ydim_chr * xdim_chr);
    psnr->v = -10 * log10(plse);
    return 0;
}

int snr_snr(snrvals *dist,image_frame *f1,image_frame *f2)
{
    unsigned int ydim,ydim_chr;
    unsigned int i,j,xdim,xdim_chr;
    double sumsqr=0;
    int ival;
    // double plse;

    xdim = f1->cols;
    xdim_chr = xdim >> 1;
    ydim = f1->rows;
    ydim_chr = ydim >> 1;
    /* Calculate psnr for Y component */
    sumsqr = 0;
    for (i = 0; i < ydim; i++)
    {
        for (j = 0; j < xdim; j++)
        {
            ival = abs(f1->Y[i][j] - f2->Y[i][j]);
            sumsqr += (float)(ival * ival);
        }
    }
   // plse = sumsqr / (65025.0 * ydim * xdim);
    dist->y = sumsqr;
    /* Calculate psnr for U component */
    sumsqr = 0;
    for (i = 0; i < ydim_chr; i++)
    {
        for (j = 0; j < xdim_chr; j++)
        {
            ival = abs(f1->U[i][j] - f2->U[i][j]);
            sumsqr += (ival * ival);
        }
    }
    //plse = sumsqr / (65025.0 * ydim_chr * xdim_chr);
    dist->u = sumsqr;//-10 * log10(plse);
    /* Calculate psnr for V component */
    sumsqr = 0;
    for (i = 0; i < ydim_chr; i++)
    {
        for (j = 0; j < xdim_chr; j++)
        {
            ival = abs(f1->V[i][j] - f2->V[i][j]);
            sumsqr += (ival * ival);
        }
    }
    //plse = sumsqr / (65025.0 * ydim_chr * xdim_chr);
    dist->v = sumsqr;//-10 * log10(plse);
    return 0;
}
    
